#!/usr/bin/env node

module.exports = (function(){
    process.env.NODE_TLS_REJECT_UNAUTHORIZED = "0";

    var ConfigFileReadPlugin = require('../core-plugins/readConfigFile');

    var file = process.cwd() + '/pr-conf.json';

    if(process.argv.length > 2){
        file = process.cwd() + '/' + process.argv[2];
    }

    process.on('uncaughtException', function(err){
        console.log('', err);
    });

    ConfigFileReadPlugin({
        file : file
    }, function (err, configFile){
        if(err){
            console.log('configFileRead', err.stack);
            configFile = require('../defaultConfig.json');
        }

        //console.log('', configFile);

        var pluginLoader = require('../core-plugins/pluginLoader');

        pluginLoader(configFile, function(err, plugins){

            if(err){
                console.log('', err);
                return;
            }

            var state = {
                created : new Date().toDateString().replace(/ /g, '_'),
                ts : new Date().toISOString()
            };

            var whenDone = function(state){
                var prBuilder = require('../core-plugins/prBuilder');
                var prCopy = require('../core-plugins/pbCopy');
                var prLink = require('../core-plugins/prLink');

                // TODO: fix nesting issue later
                prBuilder(configFile, state, function(){
                    prCopy(configFile, state, function () {
                        prLink(configFile, state, function () {
                            console.log('Done');
                        });
                    });
                });
            };

            function nextPlugin(){
                var plug = plugins.shift();
                if(!plug){
                    whenDone(state);
                }
                else if(plug && typeof plug.__module === 'function'){
                    plug.__module(configFile, state, nextPlugin);
                }
            }

            nextPlugin();

        });

    });

})();